c
c	DC _et solver (very primitive) for VBIC95.
c	This program reads in a parameter list (in the order defined
c	in the model definition, from a file called PARS with entries
c	that are value/name pairs), and then reads applied biases
c	from stdin and prints output to stdout. Please note that
c	the resistances cannot be zero for this solver, and that
c	the solution strategy is a dumb, bounded NR.
c
	double precision p(200),pnom(200),vx(4)
	implicit double precision (a-z)
	integer npar,nit,iargc,nargs
	character*20 parnam,arg
	open(31,file='PARS')
	npar=1
	ifirst=0
	rewind(31)
10	continue
	read(31,*,end=20) pnom(npar),parnam
	npar=npar+1
	goto 10
20	continue
	close(31)
	npar=npar-1
c
c	Abort if any resistances are too small
c
	if(pnom( 2).lt.1.0d-6) goto 1000
	if(pnom( 3).lt.1.0d-6) goto 1000
	if(pnom( 7).lt.1.0d-6) goto 1000
	if(pnom( 8).lt.1.0d-6) goto 1000
	if(pnom( 9).lt.1.0d-6) goto 1000
	if(pnom(10).lt.1.0d-6) goto 1000
	if(pnom(11).lt.1.0d-6) goto 1000
	if(pnom(84).lt.1.0d-6) goto 1000
c
c	Call temperature mapping routine, TAMB can be changed
c	using the -t flag
c
	TAMB=27.0d0
	nargs=iargc()
	if (nargs.gt.1) then
	   call getarg(1,arg)
	   if (arg.eq."-t".and.nargs.ge.2) then
	      call getarg(2,arg)
	      read(arg,*) TAMB
	   endif
	endif
	call vbict(p,pnom,TAMB)
c
c	Inputs  are: v(c) i(b) v(e) v(s)
c	Outputs are: i(c) v(b) i(e) dt
c
	write(6,*) 'Inputs  are: v(c) i(b) v(e) v(s)'
	write(6,*) 'Outputs are: i(c) v(b) i(e) dt'
	SCALE=1.0d0
100	continue
	read(5,*,end=200) vx(1),vx(2),vx(3),vx(4)
	call solver(vx,p,ic,vb,ie,is,dt,nit,SCALE)
	write(6,201) vx(1),vx(2),vx(3),vx(4),ic,vb,ie,dt,nit
	goto 100
200	continue
201	format(0pf7.3,1pe11.3,2(0pf7.3),4(1x,1pe11.3),i4)
c
c
c
1000	continue
	end
c
c	Test  solver for VBIC
c
	subroutine solver(vx,p,ic,vb,ie,is,dt,nit,scale)
	implicit double precision (a-z)
	integer nit,itmax,ii,jj,ipvt(9)
	double precision vx(4)
	double precision v(9)
	double precision rhs(9)
	double precision c(9,9)
	double precision g(9,9)
	double precision p(200)
c
c	Node order list:
c
c	bi    1
c	ei    2
c	ci    3
c	cx    4
c	bp    5
c	bx    6
c	si    7
c	t     8
c	b     9
c
c	Initialize node voltages
c
	v(1)=0.5d0
	v(2)=vx(3)
	v(3)=vx(1)
	v(4)=vx(1)
	v(5)=vx(1)
	v(6)=0.5d0
	v(7)=vx(4)
	v(8)=0.0d0
	v(9)=0.5d0
c
c	NR Loop
c
	nit=0
	itmax=200
	dvmax=0.2d0
	dtmax=10.0d0
	errtol=1.0d-6
10	continue
c
c	Calculate branch voltages
c
	Vbe=v(9)-vx(3)
	Vbc=v(9)-vx(1)
	Vbei=v(1)-v(2)
	Vbex=v(6)-v(2)
	Vbci=v(1)-v(3)
	Vrcx=vx(1)-v(4)
	Vrci=v(4)-v(3)
	Vrbx=v(9)-v(6)
	Vrbi=v(6)-v(1)
	Vre=vx(3)-v(2)
	Vrs=vx(4)-v(7)
	Vbep=v(6)-v(5)
	Vbcp=v(7)-v(5)
	Vrbp=v(4)-v(5)
	delT=v(8)
c
c	Clear rhs and conductance matrix
c
	do 110 ii=1,9
		rhs(ii)=0.0d0
		do 105 jj=1,9
			G(ii,jj)=0.0d0
			C(ii,jj)=0.0d0
105		continue
110	continue
c
c	Evaluate branch currents, charges, and their derivatives
c	(polarity is positive flowing into a node)
c
	call vbicfj_et(p,
     +	Vbe,Vbc,Vbei,Vbex,Vbci,Vrcx,Vrci,Vrbx,
     +	Vrbi,Vre,Vrs,Vbep,Vbcp,Vrbp,delT,
     +	Itzf,Itzf_Vbei,Itzf_Vbci,Itzf_delT,
     +	Itzr,Itzr_Vbei,Itzr_Vbci,Itzr_delT,
     +	Ibe,Ibe_Vbei,Ibe_delT,
     +	Ibex,Ibex_Vbex,Ibex_delT,
     +	Ibc,Ibc_Vbci,Ibc_delT,
     +	Igc,Igc_Vbei,Igc_Vbci,Igc_delT,
     +	Ircx,Ircx_Vrcx,Ircx_delT,
     +	Irci,Irci_Vbci,Irci_Vrci,Irci_delT,
     +	Irbx,Irbx_Vrbx,Irbx_delT,
     +	Irbi,Irbi_Vrbi,Irbi_Vbei,Irbi_Vbci,Irbi_delT,
     +	Ire,Ire_Vre,Ire_delT,
     +	Irs,Irs_Vrs,Irs_delT,
     +	Iccp,Iccp_Vbep,Iccp_Vbcp,Iccp_Vbci,Iccp_delT,
     +	Ibep,Ibep_Vbep,Ibep_delT,
     +	Ibcp,Ibcp_Vbcp,Ibcp_delT,
     +	Irbp,Irbp_Vrbp,Irbp_Vbep,Irbp_Vbci,Irbp_delT,
     +	Ith,Ith_Vbei,Ith_Vbci,Ith_Vrcx,Ith_Vrci,Ith_Vrbx,
     +	Ith_Vrbi,Ith_Vre,Ith_Vbep,Ith_Vbcp,Ith_Vrbp,Ith_Vrs,
     +	Ith_Vbex,Ith_delT,
     +	Irth,Irth_delT,
     +	Qbeo,Qbeo_Vbe,
     +	Qbco,Qbco_Vbc,
     +	Qbe,Qbe_Vbei,Qbe_Vbci,Qbe_delT,
     +	Qbex,Qbex_Vbex,Qbex_delT,
     +	Qbc,Qbc_Vbci,Qbc_delT,
     +	Qbcx,Qbcx_Vbci,Qbcx_Vrci,Qbcx_delT,
     +	Qbep,Qbep_Vbep,Qbep_Vbci,Qbep_delT,
     +	Qbcp,Qbcp_Vbcp,Qbcp_delT,
     +	Qcth,Qcth_delT,
     +	scale)
c
c	Stamp element: Itzf
c
	rhs(3)=rhs(3)-Itzf
	G(3,1)=G(3,1)-Itzf_Vbei
	G(3,2)=G(3,2)+Itzf_Vbei
	G(3,1)=G(3,1)-Itzf_Vbci
	G(3,3)=G(3,3)+Itzf_Vbci
	G(3,8)=G(3,8)-Itzf_delT
	rhs(2)=rhs(2)+Itzf
	G(2,1)=G(2,1)+Itzf_Vbei
	G(2,2)=G(2,2)-Itzf_Vbei
	G(2,1)=G(2,1)+Itzf_Vbci
	G(2,3)=G(2,3)-Itzf_Vbci
	G(2,8)=G(2,8)+Itzf_delT
c
c	Stamp element: Itzr
c
	rhs(2)=rhs(2)-Itzr
	G(2,1)=G(2,1)-Itzr_Vbei
	G(2,2)=G(2,2)+Itzr_Vbei
	G(2,1)=G(2,1)-Itzr_Vbci
	G(2,3)=G(2,3)+Itzr_Vbci
	G(2,8)=G(2,8)-Itzr_delT
	rhs(3)=rhs(3)+Itzr
	G(3,1)=G(3,1)+Itzr_Vbei
	G(3,2)=G(3,2)-Itzr_Vbei
	G(3,1)=G(3,1)+Itzr_Vbci
	G(3,3)=G(3,3)-Itzr_Vbci
	G(3,8)=G(3,8)+Itzr_delT
c
c	Stamp element: Ibe
c
	rhs(1)=rhs(1)-Ibe
	G(1,1)=G(1,1)-Ibe_Vbei
	G(1,2)=G(1,2)+Ibe_Vbei
	G(1,8)=G(1,8)-Ibe_delT
	rhs(2)=rhs(2)+Ibe
	G(2,1)=G(2,1)+Ibe_Vbei
	G(2,2)=G(2,2)-Ibe_Vbei
	G(2,8)=G(2,8)+Ibe_delT
c
c	Stamp element: Ibex
c
	rhs(6)=rhs(6)-Ibex
	G(6,6)=G(6,6)-Ibex_Vbex
	G(6,2)=G(6,2)+Ibex_Vbex
	G(6,8)=G(6,8)-Ibex_delT
	rhs(2)=rhs(2)+Ibex
	G(2,6)=G(2,6)+Ibex_Vbex
	G(2,2)=G(2,2)-Ibex_Vbex
	G(2,8)=G(2,8)+Ibex_delT
c
c	Stamp element: Ibc
c
	rhs(1)=rhs(1)-Ibc
	G(1,1)=G(1,1)-Ibc_Vbci
	G(1,3)=G(1,3)+Ibc_Vbci
	G(1,8)=G(1,8)-Ibc_delT
	rhs(3)=rhs(3)+Ibc
	G(3,1)=G(3,1)+Ibc_Vbci
	G(3,3)=G(3,3)-Ibc_Vbci
	G(3,8)=G(3,8)+Ibc_delT
c
c	Stamp element: Igc
c
	rhs(3)=rhs(3)-Igc
	G(3,1)=G(3,1)-Igc_Vbei
	G(3,2)=G(3,2)+Igc_Vbei
	G(3,1)=G(3,1)-Igc_Vbci
	G(3,3)=G(3,3)+Igc_Vbci
	G(3,8)=G(3,8)-Igc_delT
	rhs(1)=rhs(1)+Igc
	G(1,1)=G(1,1)+Igc_Vbei
	G(1,2)=G(1,2)-Igc_Vbei
	G(1,1)=G(1,1)+Igc_Vbci
	G(1,3)=G(1,3)-Igc_Vbci
	G(1,8)=G(1,8)+Igc_delT
c
c	Stamp element: Ircx
c
	rhs(4)=rhs(4)+Ircx
	G(4,4)=G(4,4)-Ircx_Vrcx
	G(4,8)=G(4,8)+Ircx_delT
c
c	Stamp element: Irci
c
	rhs(4)=rhs(4)-Irci
	G(4,1)=G(4,1)-Irci_Vbci
	G(4,3)=G(4,3)+Irci_Vbci
	G(4,4)=G(4,4)-Irci_Vrci
	G(4,3)=G(4,3)+Irci_Vrci
	G(4,8)=G(4,8)-Irci_delT
	rhs(3)=rhs(3)+Irci
	G(3,1)=G(3,1)+Irci_Vbci
	G(3,3)=G(3,3)-Irci_Vbci
	G(3,4)=G(3,4)+Irci_Vrci
	G(3,3)=G(3,3)-Irci_Vrci
	G(3,8)=G(3,8)+Irci_delT
c
c	Stamp element: Irbx
c
	rhs(6)=rhs(6)+Irbx
	G(6,6)=G(6,6)-Irbx_Vrbx
	G(6,8)=G(6,8)+Irbx_delT
c
c	Stamp element: Irbi
c
	rhs(6)=rhs(6)-Irbi
	G(6,6)=G(6,6)-Irbi_Vrbi
	G(6,1)=G(6,1)+Irbi_Vrbi
	G(6,1)=G(6,1)-Irbi_Vbei
	G(6,2)=G(6,2)+Irbi_Vbei
	G(6,1)=G(6,1)-Irbi_Vbci
	G(6,3)=G(6,3)+Irbi_Vbci
	G(6,8)=G(6,8)-Irbi_delT
	rhs(1)=rhs(1)+Irbi
	G(1,6)=G(1,6)+Irbi_Vrbi
	G(1,1)=G(1,1)-Irbi_Vrbi
	G(1,1)=G(1,1)+Irbi_Vbei
	G(1,2)=G(1,2)-Irbi_Vbei
	G(1,1)=G(1,1)+Irbi_Vbci
	G(1,3)=G(1,3)-Irbi_Vbci
	G(1,8)=G(1,8)+Irbi_delT
c
c	Stamp element: Ire
c
	rhs(2)=rhs(2)+Ire
	G(2,2)=G(2,2)-Ire_Vre
	G(2,8)=G(2,8)+Ire_delT
c
c	Stamp element: Irs
c
	rhs(7)=rhs(7)+Irs
	G(7,7)=G(7,7)-Irs_Vrs
	G(7,8)=G(7,8)+Irs_delT
c
c	Stamp element: Iccp
c
	rhs(6)=rhs(6)-Iccp
	G(6,6)=G(6,6)-Iccp_Vbep
	G(6,5)=G(6,5)+Iccp_Vbep
	G(6,7)=G(6,7)-Iccp_Vbcp
	G(6,5)=G(6,5)+Iccp_Vbcp
	G(6,1)=G(6,1)-Iccp_Vbci
	G(6,3)=G(6,3)+Iccp_Vbci
	G(6,8)=G(6,8)-Iccp_delT
	rhs(7)=rhs(7)+Iccp
	G(7,6)=G(7,6)+Iccp_Vbep
	G(7,5)=G(7,5)-Iccp_Vbep
	G(7,7)=G(7,7)+Iccp_Vbcp
	G(7,5)=G(7,5)-Iccp_Vbcp
	G(7,1)=G(7,1)+Iccp_Vbci
	G(7,3)=G(7,3)-Iccp_Vbci
	G(7,8)=G(7,8)+Iccp_delT
c
c	Stamp element: Ibep
c
	rhs(6)=rhs(6)-Ibep
	G(6,6)=G(6,6)-Ibep_Vbep
	G(6,5)=G(6,5)+Ibep_Vbep
	G(6,8)=G(6,8)-Ibep_delT
	rhs(5)=rhs(5)+Ibep
	G(5,6)=G(5,6)+Ibep_Vbep
	G(5,5)=G(5,5)-Ibep_Vbep
	G(5,8)=G(5,8)+Ibep_delT
c
c	Stamp element: Ibcp
c
	rhs(7)=rhs(7)-Ibcp
	G(7,7)=G(7,7)-Ibcp_Vbcp
	G(7,5)=G(7,5)+Ibcp_Vbcp
	G(7,8)=G(7,8)-Ibcp_delT
	rhs(5)=rhs(5)+Ibcp
	G(5,7)=G(5,7)+Ibcp_Vbcp
	G(5,5)=G(5,5)-Ibcp_Vbcp
	G(5,8)=G(5,8)+Ibcp_delT
c
c	Stamp element: Irbp
c
	rhs(4)=rhs(4)-Irbp
	G(4,4)=G(4,4)-Irbp_Vrbp
	G(4,5)=G(4,5)+Irbp_Vrbp
	G(4,6)=G(4,6)-Irbp_Vbep
	G(4,5)=G(4,5)+Irbp_Vbep
	G(4,1)=G(4,1)-Irbp_Vbci
	G(4,3)=G(4,3)+Irbp_Vbci
	G(4,8)=G(4,8)-Irbp_delT
	rhs(5)=rhs(5)+Irbp
	G(5,4)=G(5,4)+Irbp_Vrbp
	G(5,5)=G(5,5)-Irbp_Vrbp
	G(5,6)=G(5,6)+Irbp_Vbep
	G(5,5)=G(5,5)-Irbp_Vbep
	G(5,1)=G(5,1)+Irbp_Vbci
	G(5,3)=G(5,3)-Irbp_Vbci
	G(5,8)=G(5,8)+Irbp_delT
c
c	Stamp element: Ith
c
	rhs(8)=rhs(8)+Ith
	G(8,1)=G(8,1)+Ith_Vbei
	G(8,2)=G(8,2)-Ith_Vbei
	G(8,1)=G(8,1)+Ith_Vbci
	G(8,3)=G(8,3)-Ith_Vbci
	G(8,4)=G(8,4)-Ith_Vrcx
	G(8,4)=G(8,4)+Ith_Vrci
	G(8,3)=G(8,3)-Ith_Vrci
	G(8,6)=G(8,6)-Ith_Vrbx
	G(8,6)=G(8,6)+Ith_Vrbi
	G(8,1)=G(8,1)-Ith_Vrbi
	G(8,2)=G(8,2)-Ith_Vre
	G(8,6)=G(8,6)+Ith_Vbep
	G(8,5)=G(8,5)-Ith_Vbep
	G(8,7)=G(8,7)+Ith_Vbcp
	G(8,5)=G(8,5)-Ith_Vbcp
	G(8,4)=G(8,4)+Ith_Vrbp
	G(8,5)=G(8,5)-Ith_Vrbp
	G(8,7)=G(8,7)-Ith_Vrs
	G(8,6)=G(8,6)+Ith_Vbex
	G(8,2)=G(8,2)-Ith_Vbex
	G(8,8)=G(8,8)+Ith_delT
c
c	Stamp element: Irth
c
	rhs(8)=rhs(8)-Irth
	G(8,8)=G(8,8)-Irth_delT
c
c	Stamp for node b
c
	rhs(9)=rhs(9)+vx(2)
	rhs(9)=rhs(9)-Irbx
	G(9,9)=G(9,9)-Irbx_Vrbx
	G(9,6)=G(9,6)+Irbx_Vrbx
	G(6,9)=G(6,9)+Irbx_Vrbx
	G(9,8)=G(9,8)-Irbx_delT
c
c	Solve for update vector, update, and check convergence
c
	fnorm=0.0d0
	do 50 ii=1,9
		fnorm=fnorm+rhs(ii)**2
50	continue
	fnorm=sqrt(fnorm)
	call decomp(G,9,ipvt)
	call solve(G,9,ipvt,rhs)
	vscale=1.0d0
	do 55 ii=1,9
		if(ii.ne.8)then
		   if(abs(rhs(ii)/dvmax).gt.1.0d0/vscale)then
			vscale=abs(dvmax/rhs(ii))
		   endif
		endif
55	continue
	dnorm=0.0d0
	do 60 ii=1,9
		if(ii.ne.8)then
			rhs(ii)=rhs(ii)*vscale
			dnorm=dnorm+rhs(ii)**2
			v(ii)=v(ii)-rhs(ii)
		endif
60	continue
	vscale=1.0d0
	ii=8
	if(abs(rhs(ii)/dtmax).gt.1.0d0/vscale)then
		vscale=abs(dtmax/rhs(ii))
	endif
	rhs(ii)=rhs(ii)*vscale
	dnorm=dnorm+rhs(ii)**2
	v(ii)=v(ii)-rhs(ii)
	dnorm=sqrt(dnorm)
	nit=nit+1
	if(nit.lt.itmax.and.fnorm.gt.errtol.and.dnorm.gt.errtol) goto 10
	ic=Itzf-Itzr-Ibc+Igc+Irbp
	vb=v(9)
	ib=vx(2)
	ie=-Itzf+Itzr-Ibe-Ibex
	is=-ic-ib-ie
	dt=v(8)
	return
	end
c
c	FMM forward decomposition and back substitution routines
c
	subroutine decomp(a,n,ipvt)
	double precision a(n,n)
	integer n,ipvt(n)
	integer nm1,k,kp1,m,i,j
	double precision t
	ipvt(n)=1
	nm1 = n-1
	do 35 k=1,nm1
		kp1=k+1
		m=k
		do 15 i=kp1,n
			if(abs(a(i,k)).gt.abs(a(m,k))) m=i
15		continue
		ipvt(k)=m
		if(m.ne.k) ipvt(n)=-ipvt(n)
		t=a(m,k)
		a(m,k)=a(k,k)
		a(k,k)=t
		if(t .eq. 0.0) then
			write(6,*) 'ZERO PIVOT'
			call exit(1)
		endif
		do 20 i=kp1,n
			a(i,k) = -a(i,k)/t
20		continue
		do 30 j=kp1,n
			t=a(m,j)
			a(m,j)=a(k,j)
			a(k,j)=t
			do 25 i=kp1,n
				a(i,j)=a(i,j)+a(i,k)*t
25			continue
30		continue
35	continue
	return
	end
	subroutine solve(a,n,ipvt,b)
	double precision a(n,n),b(n)
	integer n,ipvt(n)
	integer nm1,k,kp1,m,i,kb,km1
	double precision t
	nm1=n-1
	do 20 k=1,nm1
		kp1=k+1
		m=ipvt(k)
		t=b(m)
		b(m)=b(k)
		b(k)=t
		do 10 i=kp1,n
			b(i)=b(i)+a(i,k)*t
10		continue
20	continue
	do 40 kb=1,nm1
		km1=n-kb
		k=km1+1
		b(k)=b(k)/a(k,k)
		t=-b(k)
		do 30 i=1,km1
			b(i)=b(i)+a(i,k)*t
30		continue
40	continue
	b(1)=b(1)/a(1,1)
	return
	end
